su(1)

НАЗВАНИЕ
su - изменяет ID пользователя или делает его суперпользователем

СИНТАКСИС

su [параметры] [-] [имя_пользователя [ args ]]

ОПИСАНИЕ

The su command is used to become another user during a login session. Invoked without a username, su defaults to becoming the superuser. The - option may be used to provide an environment similar to what the user would expect had the user logged in directly. The -c option may be used to treat the next argument as a command by most shells.

Options are recognized everywhere in the argument list. You can use the -- argument to stop option parsing. The - option is special: it is also recognized after --, but has to be placed before username.

Пользователю предложат ввести пароль, если он задан. При неверном пароле возникает сообщение об ошибке. Все попытки, удачные и неудачные, протоколируются системой с целью обнаружения злоупотреблений.

The current environment is passed to the new shell. The value of $PATH is reset to /bin:/usr/bin for normal users, or /sbin:/bin:/usr/sbin:/usr/bin for the superuser. This may be changed with the ENV_PATH and ENV_SUPATH definitions in /etc/login.defs.

Субсистемный вход в систему можно распознать по наличию символа «*» в начале регистрационной оболочки. Заданный домашний каталог будет использован как корень новой файловой системы, в которой регистрируется пользователь.

ПАРАМЕТРЫ

The options which apply to the su command are:

-c, --command COMMAND
    Specify a command that will be invoked by the shell using its -c.

    The executed command will have no controlling terminal. This option cannot be used to execute interactive programs which need a controlling TTY.

-, -l, --login
    Предоставляет окружение, как если бы пользователь непосредственно регистрировался в системе.

    When - is used, it must be specified before any username. For portability it is recommended to use it as last option, before any username. The other forms (-l and --login) do not have this restriction.

-s, --shell SHELL
    Оболочка, которая будет запущена.

    The invoked shell is chosen from (highest priority first):

        The shell specified with --shell.

        If --preserve-environment is used, the shell specified by the $SHELL environment variable.

        The shell indicated in the /etc/passwd entry for the target user.

        /bin/sh if a shell could not be found by any above method.

    If the target user has a restricted shell (i.e. the shell field of this user's entry in /etc/passwd is not listed in /etc/shells), then the --shell option or the $SHELL environment variable won't be taken into account, unless su is called by root.

-m, -p, --preserve-environment
    Preserve the current environment, except for:

    $PATH
        reset according to the /etc/login.defs options ENV_PATH or ENV_SUPATH (see below);

    $IFS
        reset to «<space><tab><newline>», if it was set.

    If the target user has a restricted shell, this option has no effect (unless su is called by root).

    Note that the default behavior for the environment is the following:

        The $HOME, $SHELL, $USER, $LOGNAME, $PATH, and $IFS environment variables are reset.

        If --login is not used, the environment is copied, except for the variables above.

        If --login is used, the $TERM, $COLORTERM, $DISPLAY, and $XAUTHORITY environment variables are copied if they were set.

        If --login is used, the $TZ, $HZ, and $MAIL environment variables are set according to the /etc/login.defs options ENV_TZ, ENV_HZ, MAIL_DIR, and MAIL_FILE (see below).

        If --login is used, other environment variables might be set by the ENVIRON_FILE file (see below).

ПРЕДОСТЕРЕЖЕНИЯ

This version of su has many compilation options, only some of which may be in use at any particular site.

НАСТРОЙКА

The following configuration variables in /etc/login.defs change the behavior of this tool:

CONSOLE (string)
    Если определена, то значение равно или полному пути к файлу с именами устройств (одно на строку), или списку имён устройств, перечисленных через «:». Вход суперпользователя будет разрешён только с этих устройств.

    Если не определена, то суперпользователь может входить в систему с любого устройства.

    Устройства должны указываться без начального префикса /dev/.

CONSOLE_GROUPS (string)
    List of groups to add to the user's supplementary groups set when logging in on the console (as determined by the CONSOLE setting). Default is none.

    Use with caution - it is possible for users to gain permanent access to these groups, even when not logged in on the console.

DEFAULT_HOME (boolean)
    Определяет, можно ли войти в систему, если нельзя выполнить cd в домашний каталог. По умолчанию «no».

    If set to yes, the user will login in the root (/) directory if it is not possible to cd to her home directory.

ENV_HZ (string)
    If set, it will be used to define the HZ environment variable when a user login. The value must be preceded by HZ=. A common value on Linux is HZ=100.

ENVIRON_FILE (string)
    Если этот файл существует и доступ для чтения, то из него читает регистрационное окружение. Каждая строка должна иметь формат: имя=значение.

    Строки, начинающиеся с #, считаются комментарием и игнорируются.

ENV_PATH (string)
    If set, it will be used to define the PATH environment variable when a regular user login. The value is a colon separated list of paths (for example /bin:/usr/bin) and can be preceded by PATH=. The default value is PATH=/bin:/usr/bin.

ENV_SUPATH (string)
    If set, it will be used to define the PATH environment variable when the superuser login. The value is a colon separated list of paths (for example /sbin:/bin:/usr/sbin:/usr/bin) and can be preceded by PATH=. The default value is PATH=/sbin:/bin:/usr/sbin:/usr/bin.

ENV_TZ (string)
    If set, it will be used to define the TZ environment variable when a user login. The value can be the name of a timezone preceded by TZ= (for example TZ=CST6CDT), or the full path to the file containing the timezone specification (for example /etc/tzname).

    If a full path is specified but the file does not exist or cannot be read, the default is to use TZ=CST6CDT.

LOGIN_STRING (string)
    Строка-приглашение к вводу пароля. Значение по умолчанию: «Password:» или перевод этой строки на разные языки. Если вы измените эту переменную, то перевод будет отсутствовать.

    If the string contains %s, this will be replaced by the user's name.

MAIL_CHECK_ENAB (boolean)
    Включает проверку и показ состояния почтового ящика при входе.

    Вы должны выключить это, если почтовый ящик проверяется из файлов автозапуска оболочки («mailx -e» или похожей командой).

MAIL_DIR (string)
    Почтовый каталог. Данный параметр нужен для управления почтовым ящиком при изменении или удалении учётной записи пользователя. Если параметр не задан, то используется значение указанное при сборке.

MAIL_FILE (string)
    Определяет расположение почтовых файлов пользователя относительно домашнего каталога.

The MAIL_DIR and MAIL_FILE variables are used by useradd, usermod, and userdel to create, move, or delete the user's mail spool.

If MAIL_CHECK_ENAB is set to yes, they are also used to define the MAIL environment variable.

QUOTAS_ENAB (boolean)
    Enable setting of resource limits from /etc/limits and ulimit, umask, and niceness from the user's passwd gecos field.

SULOG_FILE (string)
    Если определена, то любая активность su будет протоколироваться в этот файл.

SU_NAME (string)
    Если определена, то выводится имя команды когда работает «su -». Например, если значение равно «su», то «ps» покажет команду как «-su». Если не определена, то «ps» покажет имя запускаемой оболочки например как «-sh».

SU_WHEEL_ONLY (boolean)
    If yes, the user must be listed as a member of the first gid 0 group in /etc/group (called root on most Linux systems) to be able to su to uid 0 accounts. If the group doesn't exist or is empty, no one will be able to su to uid 0.

SYSLOG_SU_ENAB (boolean)
    Enable "syslog" logging of su activity - in addition to sulog file logging.

USERGROUPS_ENAB (boolean)
    Включает установку группы битов umask равной битам владельца (пример: 022 -> 002, 077 -> 007) для не суперпользователей, если uid равен gid и имя пользователя совпадает с именем первичной группы.

    If set to yes, userdel will remove the user's group if it contains no more members, and useradd will create by default a group with the name of the user.

ФАЙЛЫ

/etc/passwd
    содержит информацию о пользователях

/etc/shadow
    содержит защищаемую информацию о пользователях

/etc/login.defs
    содержит конфигурацию подсистемы теневых паролей

ВОЗВРАЩАЕМЫЕ ЗНАЧЕНИЯ

On success, su returns the exit value of the command it executed.

If this command was terminated by a signal, su returns the number of this signal plus 128.

If su has to kill the command (because it was asked to terminate, and the command did not terminate in time), su returns 255.

Some exit values from su are independent from the executed command:

0
    success (--help only)

1
    System or authentication failure

126
    The requested command was not found

127
    The requested command could not be executed

СМОТРИТЕ ТАКЖЕ

login(1), login.defs(5), sg(1), sh(1).